﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MetodyIWyrazeniaLambda
{
    class Klasa
    {
        public int Kwadrat(int arg)
        {
            return arg * arg;
        }
    }

    class Program
    {
        delegate int TypKwadrat(int arg);

        static void Main(string[] args)
        {
            Klasa obiekt = new Klasa();
            int wynik = obiekt.Kwadrat(2);
            Console.WriteLine(wynik);

            TypKwadrat metoda = obiekt.Kwadrat;
            wynik = metoda(3);
            Console.WriteLine(wynik);

            Func<int, int> metoda2 = obiekt.Kwadrat;
            wynik = metoda2(4);
            Console.WriteLine(wynik);

            Func<int, int> metoda3 =
                (int arg) => { return arg * arg; };
            wynik = metoda3(5);
            Console.WriteLine(wynik);

            Func<int, int> metoda4 =
                (arg) => arg * arg;
            wynik = metoda4(6);
            Console.WriteLine(wynik);

            int[] tablica = new int[] { 1, 4, 2, 2, 6 };
            var zapytanie = from int i in tablica
                            where i < 4
                            select i * i;
            string s = "";
            foreach (int i in zapytanie)
            {
                s += i.ToString() + " ";
            }
            Console.WriteLine(s);

            var zapytanie2 = tablica.Where(j => j < 4).Select(j => j * j);
            s = "";
            foreach (int i in zapytanie2)
            {
                s += i.ToString() + " ";
            }
            Console.WriteLine(s);

        }
    }
}
